import  java.io.*;
import  java.util.Scanner;

class node { 
   String info; 
   node next; 
} 

public class StackLinkedList { 

  static node lis;

  public static String readInfo () {
    Scanner in = new Scanner(System.in);    
    System.out.print("Insert value: ");
    String info = in.next();
    return info;
  }
 
  public static void init () {
    lis = null;
  }

  public static boolean isEmpty () { 
      return (lis == null);
  }
  
  public static void Push(String s) { 
    node p = new node();  
    p.info = s;  
    p.next = lis; 
    lis = p;
  } 

  public static void Pop() { 
    if (lis != null) 
      lis = lis.next; 
  }  

  public static String Top() { 
      if (lis != null) 
	return lis.info;
      else
        return null;
  }  

  public static void print() { 
    node p = lis; 
    while (p != null) { 
      System.out.printf(" %s ", p.info); 
      p = p.next;
    } 
    System.out.println(); 
  } 
  
  
  public static void main(String args[]) {
      Scanner in = new Scanner(System.in);  
      String info = null;
      int pos = -1;
      
      char option = 'a';
      String opt = null;
      init();
      do {
	    System.out.println("Options:");
	    System.out.println(" e: check if the list is empty");
	    System.out.println(" i: insert new element at the beginning");
	    System.out.println(" t: show the last-inserted element");
	    System.out.println(" d: delete the last-inserted element");
	    System.out.println(" p: print list");
          opt = in.next(); option = opt.charAt(0);
          switch (option) {
	    case 'e': 
	      if (isEmpty())
                 System.out.println("The list is empty");
              else
                 System.out.println("The list is not empty");
		break;
	    case 'i': 
              info = readInfo();
              Push(info);
		break;
	    case 'd': 
              Pop();
		break;
	    case 't': 
              info= Top();
              if (info != null)
                 System.out.println(info);
	      break;
	    case 'p': 
              print();
		break;
	    }
	} while (
         option == 'e' || 
         option == 'i' || 
         option == 't' || 
         option == 'd' || 
         option == 'p' 
        );
  }
}  
