import  java.io.*;
import  java.util.Scanner;

class node { 
   String info; 
   node next; 
} 


public class QueueLinkedList {

    static node head,tail;

   public static String readInfo () {
     Scanner in = new Scanner(System.in);    
     System.out.print("Insert value: ");
     String info = in.next();
     return info;
   }

    public static void init() {
	head = tail = null;
    }

    public static boolean isEmpty() {
	return (head == null);
    }

    public static boolean isFull() {
        return false;
    }

    public static void enqueue(String x) {
        if (!isFull()) {
          node p = new node();  
          p.info = x;p.next=null;
          if (head == null) {
	      tail = p;  
	      head = p;  
	  }
          else {
             tail.next = p;
             tail=tail.next;
	  }
	}
    }

    public static String dequeue() {
        if (!isEmpty()) {
	    String x = head.info;
            head = head.next;
            return x;
	}
        else
	   return null;
    }

    static void print () 
    {
       int i;
       node p = head;
       while (p != null) { 
          System.out.printf(" %s ", p.info); 
          p = p.next;
       }
       System.out.println(); 
    }

  public static void main(String args[]) {
      Scanner in = new Scanner(System.in);  
      String info = null;
      int pos = -1;
      
      char option = 'a';
      String opt = null;
      init();
      do {
	    System.out.println("Options:");
	    System.out.println(" e: check if the list is empty");
	    System.out.println(" i: insert a new element");
	    System.out.println(" d: delete the first-inserted element");
	    System.out.println(" p: print list");
          opt = in.next(); option = opt.charAt(0);
          switch (option) {
	    case 'e': 
	      if (isEmpty())
                 System.out.println("The queue is empty");
              else
                 System.out.println("The queue is not empty");
		break;
	    case 'i': 
              info = readInfo();
              enqueue(info);
		break;
	    case 'd': 
              info= dequeue();
              if (info != null)
                 System.out.println(info);
	      break;
	    case 'p': 
              print();
		break;
	    }
	} while (
         option == 'e' || 
         option == 'i' || 
         option == 'd' || 
         option == 'p' 
        );
  }


}
